<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );
/**
 * @package    hwdVideoShare
 * @author     Dave Horsfall <info@highwooddesign.co.uk>
 * @copyright  2008 Highwood Design
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version    1.1.4 Alpha RC3.5
 */
class hwd_vs_videoplayer {
    /**
     * Prepares the code to insert the third party video
     *
     * @param string $option  the $video_id output containing video paramters
     * @param int    $flv_width  the video width
     * @param int    $flv_height  the video height
     * @return       $code   the third party embed code
     */
    function prepareplayer($flv_path, $flv_width=427, $flv_height=340, $ui=0, $mediatype="video")
	{
		global $task, $smarty, $option, $mainframe;
		if (!defined('HWDVIDSPATH')) { define('HWDVIDSPATH', dirname(__FILE__).'/../../'); }
		$c = hwd_vs_Config::get_instance();
		$code=null;

		$params = $this->getMyParams( $option, $task, 5);

	    if (isset($flv_width)) {
	    	$param_width = $flv_width;
	    } else {
	    	$param_width = $params->get('width', '427');
		}
	    if (isset($flv_height)) {
	    	$param_height = $flv_height;
	    } else {
	    	$param_height = $params->get('height', '340');
		}

	    $param_bgcolor = $params->get('bgcolor', '051615');
	    $param_fgcolor = $params->get('fgcolor', '13ABEC');
	    $param_autoplay = $params->get('autoplay', 'no');
	    $param_autoload = $params->get('autoload', 'no');
	    $param_autorewind = $params->get('autorewind', 'no');
	    $param_volume = $params->get('volume', '60');
	    $param_loop = $params->get('loop', 'no');
	    $param_mute = $params->get('mute', 'no');
	    $param_muteonly = $params->get('muteonly', 'no');
	    $param_clickurl = $params->get('clickurl', '');
	    $param_clicktarget = $params->get('clicktarget', '_blank');

		$smarty->assign("player_width", $param_width);

		if (!defined( '_HWD_VS_SWFOFLAG' )) {
			define( '_HWD_VS_SWFOFLAG', 1 );
			if ($option == "com_hwdvideoshare") {
				$mainframe->addCustomHeadTag('<script type="text/javascript" src="'.JURI::root( true ).'/components/com_hwdvideoshare/js/swfobject.js"></script>');
				if (($c->loadmootools == "on") && (strpos(JURI::base(true), "/administrator") === false)) {
					$mainframe->addCustomHeadTag('<script type="text/javascript" src="'.JURI::root( true ).'/components/com_hwdvideoshare/js/mootools-1.2-core-yc.js"></script>');
				}
			} else {
				$code.='<script type="text/javascript" src="'.JURI::root( true ).'/components/com_hwdvideoshare/js/swfobject.js"></script>';
				if ($c->loadmootools == "on") {
					$code.='<script type="text/javascript" src="'.JURI::root( true ).'/components/com_hwdvideoshare/js/mootools-1.2-core-yc.js"></script>';
				}
			}

		}

			$code.="<div id=\"flashcontent_".$ui."\" style=\"text-align: inherit;\">"._HWDVIDS_INFO_ENABLEJAVA."</div>
					<script type=\"text/javascript\">
					window.addEvent('domready', function(){
					   var so_".$ui." = new SWFObject(\"".JURI::root()."/components/com_hwdvideoshare/core/videoplayer/osflv/mediaplayer.swf?".rand()."\", \"hwdvideo_".$ui."\", \"".$param_width."\", \"".$param_height."\", \"8\", \"#".$param_bgcolor."\");
					   so_".$ui.".addParam(\"allowFullScreen\", \"true\");
					   so_".$ui.".addParam(\"quality\", \"high\");
                       so_".$ui.".addParam(\"wmode\", \"transparent\");
					   so_".$ui.".addVariable(\"bgcolor\", \"".$param_bgcolor."\");
					   so_".$ui.".addVariable(\"fgcolor\", \"".$param_fgcolor."\");
					   so_".$ui.".addVariable(\"volume\", \"".$param_volume."\");
					   so_".$ui.".addVariable(\"width\",\"".$param_width."\");
					   so_".$ui.".addVariable(\"height\",\"".$param_height."\");";
			if ($param_autoplay == "yes") { $code.="so_".$ui.".addVariable(\"autoplay\", \"true\");"; }
			if ($param_autoload == "yes") { $code.="so_".$ui.".addVariable(\"autoload\", \"true\");"; }
			if ($param_autorewind == "yes") { $code.="so_".$ui.".addVariable(\"autorewind\", \"true\");"; }
			if ($param_loop == "yes") { $code.="so_".$ui.".addVariable(\"loop\", \"true\");"; }
			if ($param_mute == "yes") { $code.="so_".$ui.".addVariable(\"mute\", \"true\");"; }
			if ($param_muteonly == "yes") { $code.="so_".$ui.".addVariable(\"muteonly\", \"true\");"; }
			if (!empty($param_clickurl)) { $code.="so_".$ui.".addVariable(\"clickurl\", \"".$param_clickurl."\");"; }
			if (!empty($param_clickurl)) { $code.="so_".$ui.".addVariable(\"clicktarget\", \"".$param_clicktarget."\");"; }
			$code.="   so_".$ui.".addVariable(\"movie\", \"".$flv_path."\");
					   so_".$ui.".write(\"flashcontent_".$ui."\");
					});
					</script>";
			return $code;
	}
    function prepareEmbeddedPlayer($flv_path, $flv_width=427, $flv_height=340, $video_type=null)
	{
		global $task, $smarty, $mainframe;
		if (!defined('HWDVIDSPATH')) { define('HWDVIDSPATH', dirname(__FILE__).'/../../'); }
		$c = hwd_vs_Config::get_instance();
		$code=null;

		$params = $this->getMyParams( $option, $task, 5);

	    if (isset($flv_width)) {
	    	$param_width = $flv_width;
	    } else {
	    	$param_width = $params->get('width', '427');
		}
	    if (isset($flv_height)) {
	    	$param_height = $flv_height;
	    } else {
	    	$param_height = $params->get('height', '340');
		}

	    $param_bgcolor = $params->get('bgcolor', '051615');
	    $param_fgcolor = $params->get('fgcolor', '13ABEC');
	    $param_autoplay = $params->get('autoplay', 'no');
	    $param_autoload = $params->get('autoload', 'no');
	    $param_autorewind = $params->get('autorewind', 'no');
	    $param_volume = $params->get('volume', '60');
	    $param_loop = $params->get('loop', 'no');
	    $param_mute = $params->get('mute', 'no');
	    $param_muteonly = $params->get('muteonly', 'no');
	    $param_clickurl = $params->get('clickurl', '');
	    $param_clicktarget = $params->get('clicktarget', '_blank');

        $embed_insert = null;
        $embed_insert.= "bgcolor=".$param_bgcolor;
        $embed_insert.= "&fgcolor=".$param_fgcolor;
        $embed_insert.= "&volume=".$param_volume;
		if ($param_autoplay == "yes") { $embed_insert.= "&autoplay=true"; }
		if ($param_autoload == "yes") { $embed_insert.= "&autoload=true"; }
		if ($param_autorewind == "yes") { $embed_insert.= "&autorewind=true"; }
		if ($param_loop == "yes") { $embed_insert.= "&loop=true"; }
		if ($param_mute == "yes") { $embed_insert.= "&mute=true"; }
		if ($param_muteonly == "yes") { $embed_insert.= "&muteonly=true"; }
		if (!empty($param_clickurl)) { $embed_insert.= "&clickurl=".$param_clickurl; }
		if (!empty($param_clickurl)) { $embed_insert.= "&clicktarget=".$param_clicktarget; }

		$smarty->assign("player_width", $param_width);

		$code .= "<object width='$param_width' height='$param_height' id='flvPlayer'>\n";
		$code .= " <param name='allowFullScreen' value='true'>\n";
		$code .= " <param name='movie' value='".JURI::root(true)."/components/com_hwdvideoshare/core/videoplayer/osflv/mediaplayer.swf?movie=".$flv_path."&".$embed_insert."'>\n";
		$code .= " <embed src='".JURI::root(true)."/components/com_hwdvideoshare/core/videoplayer/osflv/mediaplayer.swf?movie=".$flv_path."&".$embed_insert."' width='".$param_width."' height='".$param_height."' allowFullScreen='true' type='application/x-shockwave-flash'>\n";
		$code .= "</object>\n";

		return $code;
	}
    function prepareEmbedCode($flv_path, $flv_width=427, $flv_height=340)
	{
		global $task, $mosConfig_sitename, $smarty, $mainframe;
		if (!defined('HWDVIDSPATH')) { define('HWDVIDSPATH', dirname(__FILE__).'/../../'); }
		$c = hwd_vs_Config::get_instance();
		$code=null;


		$params = $this->getMyParams( $option, $task, 4);

	    if (isset($flv_width)) {
	    	$param_width = $flv_width;
	    } else {
	    	$param_width = $params->get('width', '427');
		}
	    if (isset($flv_height)) {
	    	$param_height = $flv_height;
	    } else {
	    	$param_height = $params->get('height', '340');
		}

	    $param_bgcolor = $params->get('bgcolor', '051615');
	    $param_fgcolor = $params->get('fgcolor', '13ABEC');
	    $param_autoplay = $params->get('autoplay', 'no');
	    $param_autoload = $params->get('autoload', 'no');
	    $param_autorewind = $params->get('autorewind', 'no');
	    $param_volume = $params->get('volume', '60');
	    $param_loop = $params->get('loop', 'no');
	    $param_mute = $params->get('mute', 'no');
	    $param_muteonly = $params->get('muteonly', 'no');
	    $param_clickurl = $params->get('clickurl', '');
	    $param_clicktarget = $params->get('clicktarget', '_blank');

        $embed_insert = null;
        $embed_insert.= "bgcolor=".$param_bgcolor;
        $embed_insert.= "&fgcolor=".$param_fgcolor;
        $embed_insert.= "&volume=".$param_volume;
		if ($param_autoplay == "yes") { $embed_insert.= "&autoplay=true"; }
		if ($param_autoload == "yes") { $embed_insert.= "&autoload=true"; }
		if ($param_autorewind == "yes") { $embed_insert.= "&autorewind=true"; }
		if ($param_loop == "yes") { $embed_insert.= "&loop=true"; }
		if ($param_mute == "yes") { $embed_insert.= "&mute=true"; }
		if ($param_muteonly == "yes") { $embed_insert.= "&muteonly=true"; }
		if (!empty($param_clickurl)) { $embed_insert.= "&clickurl=".$param_clickurl; }
		if (!empty($param_clickurl)) { $embed_insert.= "&clicktarget=".$param_clicktarget; }

		$smarty->assign("player_width", $param_width);



		if ($c->embedreturnlink == 1) {
			$code.='<div><center>';
		}
		$code .= '<object width=&#34;'.$param_width.'&#34; height=&#34;'.$param_height.'&#34; id=&#34;flvPlayer&#34;><param name=&#34;allowFullScreen&#34; value=&#34;true&#34;><param name=&#34;movie&#34; value=&#34;'.JURI::root(true).'/components/com_hwdvideoshare/core/videoplayer/osflv/mediaplayer.swf?movie='.$flv_path.'&'.$embed_insert.'&#34;><embed src=&#34;'.JURI::root(true).'/components/com_hwdvideoshare/core/videoplayer/osflv/mediaplayer.swf?movie='.$flv_path.'&'.$embed_insert.'&#34; width=&#34;'.$param_width.'&#34; height=&#34;'.$param_height.'&#34; allowFullScreen=&#34;true&#34; type=&#34;application/x-shockwave-flash&#34;></object>';
		if ($c->embedreturnlink == 1) {
			$code.='<br /><a href=&#34;'.JURI::root().'&#34; title=&#34;'.$mosConfig_sitename.'&#34;>'.$mosConfig_sitename.'</a></center></div>';
		}
		return $code;
	}
	/**
	* Compiles information to add or edit a plugin
	* @param string The current GET/POST option
	* @param integer The unique id of the record to edit
	*/
	function getMyParams( $option, $task, $uid) {
		global $database, $my, $mainframe, $mosConfig_absolute_path, $_HWD_VS_PLUGINS, $_POST;
		$db = & JFactory::getDBO();

		require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/source/controllers/plugins.php');
		require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/plugin.class.php');
		include_once(HWDVIDSPATH."/../../administrator/components/com_hwdvideoshare/library/cb/cb.params.php");

		$action	= null;
		$element = null;

		$row 	= new hwdvidsplugin($db);
		if ( $uid ) {
			// load the row from the db table
			$row->load( (int) $uid );
		}

		$params =& new cbParamsEditorController( $row->params, $element, $element, $row );

		return $params;

	}
}
?>