<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
 * This class is the HTML generator for hwdVideoShare frontend
 *
 * @package    hwdVideoShare
 * @author     Dave Horsfall <info@highwooddesign.co.uk>
 * @copyright  2008 Highwood Design
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version    1.1.4 Alpha RC2.13
 */
class hwd_vs_ajax
{
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function rateStarbox()
	{
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();

		if (!$my->id) {
			echo _HWDVIDS_AJAX_LOG2RATE;
			exit;
		}

		$rating = intval ( mosGetParam($_GET, 'rating') );
		$videoid = intval ( mosGetParam($_GET, 'video_id') );

		$where = ' WHERE a.userid = '.$my->id;
		$where .= ' AND a.videoid = '.$videoid;

		$db->SetQuery( 'SELECT count(*)'
               		. ' FROM #__hwdvidsrating AS a'
               		. $where
               		);
  		$total = $db->loadResult();

		if ( $total>0 ) {
			echo _HWDVIDS_AJAX_ALREADYRATE;
			exit;
		}

		//Video Details
		$query = 'SELECT *'
				. ' FROM #__hwdvidsvideos'
				. ' WHERE id = '.$videoid
				;
		$db->SetQuery( $query );
    	$db->loadObject( $row );

		$rating_number_votes = $row->rating_number_votes;
		$rating_total_points = $row->rating_total_points;

		$rating_number_votes = $rating_number_votes + 1;
		$rating_total_points = $rating_total_points + $rating;
		$new_rating = $rating_total_points / $rating_number_votes;

  		$db->setQuery( "UPDATE #__hwdvidsvideos"
                 . "\nSET rating_number_votes = $rating_number_votes, rating_total_points = $rating_total_points, updated_rating = $new_rating"
               . "\nWHERE id = $videoid"
               );

  		if (!$db->query()) {
    		echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
    		exit();
  		}

		$row = new hwdvids_rating($database);

		$_POST['userid'] = $my->id;
		$_POST['videoid'] = $videoid;

		// bind it to the table
		if (!$row -> bind($_POST)) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row -> store()) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		echo _HWDVIDS_AJAX_RATEADDED;
		hwd_vs_tools::logRating( $videoid, $rating );
		exit;
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function rateMasuga($option)
	{
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$ip = $_SERVER['REMOTE_ADDR'];

		// stop if user not logged in
		//if (!$my->id) {
		//	$new_back[] .= '<ul class="unit-rating" style="width:'.$units*$rating_unitwidth.'px;">';
		//	$new_back[] .= '<li class="current-rating" style="width:'.@number_format($new_rating,2)*$rating_unitwidth.'px;">'._HWDVIDS_INFO_CURRENTRATE.'</li>';
		//	$new_back[] .= '<li class="r1-unit">1</li>';
		//	$new_back[] .= '<li class="r2-unit">2</li>';
		//	$new_back[] .= '<li class="r3-unit">3</li>';
		//	$new_back[] .= '<li class="r4-unit">4</li>';
		//	$new_back[] .= '<li class="r5-unit">5</li>';
		//	$new_back[] .= '<li class="r6-unit">6</li>';
		//	$new_back[] .= '<li class="r7-unit">7</li>';
		//	$new_back[] .= '<li class="r8-unit">8</li>';
		//	$new_back[] .= '<li class="r9-unit">9</li>';
		//	$new_back[] .= '<li class="r10-unit">10</li>';
		//	$new_back[] .= '</ul>';
		//	$new_back[] .= '<p class="voted">'._HWDVIDS_INFO_RATED.'<strong>'.@number_format($new_rating,1).'</strong> ('.$rating_number_votes.' '.$tense.' '._HWDVIDS_INFO_M_CAST.') ';
		//	$new_back[] .= '<br /><span class="masugaerror">'._HWDVIDS_AJAX_LOG2RATE.'</span></p>';
        //
		//	$allnewback = join("\n", $new_back);
        //
		//	//name of the div id to be updated | the html that needs to be changed
		//	$output = "unit_long$id_sent|$allnewback";
		//	echo $output;
		//	exit;
		//}

		$rating = JRequest::getInt( 'j', 0, 'request' );
		$videoid = JRequest::getInt( 'q', 0, 'request' );

		if ($my->id == "0" || !$my->id || empty($my->id)) {
			$where = ' WHERE a.ip = "'.$ip.'"';
		} else {
			$where = ' WHERE a.userid = '.$my->id;
		}
		$where .= ' AND a.videoid = '.$videoid;

		//set width
		$rating_unitwidth     = 30; // the width (in pixels) of each rating unit (star, etc.)
		//getting the values
		$vote_sent = preg_replace("/[^0-9]/","",$_REQUEST['j']);
		$id_sent = preg_replace("/[^0-9a-zA-Z]/","",$_REQUEST['q']);
		$ip_num = preg_replace("/[^0-9\.]/","",$_REQUEST['t']);
		$units = preg_replace("/[^0-9]/","",$_REQUEST['c']);

		if ($vote_sent > $units) die(_HWDVIDS_ALERT_INVALVOTE); // kill the script because normal users will never see this.

		//Current Video Details
		$query = 'SELECT *'
				. ' FROM #__hwdvidsvideos'
				. ' WHERE id = '.$videoid
				;
		$db->SetQuery( $query );
    	$row = $db->loadObject();

		$rating_number_votes = $row->rating_number_votes;
		$rating_total_points = $row->rating_total_points;
		$new_rating = $rating_total_points / $rating_number_votes;
		$tense = ($rating_number_votes==1) ? "vote" : "votes"; //plural form votes/vote

		// check if user has voted already
		$db->SetQuery( 'SELECT count(*)'
					. ' FROM #__hwdvidsrating AS a'
					. $where
					);
		$total = $db->loadResult();
//echo 'SELECT count(*) FROM #__hwdvidsrating AS a'. $where;
		if ( $total>0 ) {
			$new_back[] .= '<ul class="unit-rating" style="width:'.$units*$rating_unitwidth.'px;">';
			$new_back[] .= '<li class="current-rating" style="width:'.@number_format($new_rating,2)*$rating_unitwidth.'px;">'._HWDVIDS_INFO_CURRENTRATE.'</li>';
			$new_back[] .= '<li class="r1-unit">1</li>';
			$new_back[] .= '<li class="r2-unit">2</li>';
			$new_back[] .= '<li class="r3-unit">3</li>';
			$new_back[] .= '<li class="r4-unit">4</li>';
			$new_back[] .= '<li class="r5-unit">5</li>';
			$new_back[] .= '<li class="r6-unit">6</li>';
			$new_back[] .= '<li class="r7-unit">7</li>';
			$new_back[] .= '<li class="r8-unit">8</li>';
			$new_back[] .= '<li class="r9-unit">9</li>';
			$new_back[] .= '<li class="r10-unit">10</li>';
			$new_back[] .= '</ul>';
			$new_back[] .= '<p class="voted">'._HWDVIDS_INFO_RATED.'<strong>'.@number_format($new_rating,1).'</strong> ('.$rating_number_votes.' '.$tense.' '._HWDVIDS_INFO_M_CAST.') ';
			$new_back[] .= '<br /><span class="masugaerror">'._HWDVIDS_AJAX_ALREADYRATE.'</span></p>';

			$allnewback = join("\n", $new_back);

			//name of the div id to be updated | the html that needs to be changed
			$output = "unit_long$id_sent|$allnewback";
			echo $output;
			exit;
		}

		//update rating details
		$rating_number_votes = $rating_number_votes + 1;
		$rating_total_points = $rating_total_points + $rating;
		$new_rating = $rating_total_points / $rating_number_votes;

  		$db->setQuery( "UPDATE #__hwdvidsvideos"
                 . "\nSET rating_number_votes = $rating_number_votes, rating_total_points = $rating_total_points, updated_rating = $new_rating"
               . "\nWHERE id = $videoid"
               );

  		if (!$db->query()) {
    		echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
    		exit();
  		}

 		// mark video as rated by this user
 		$row = new hwdvids_rating($db);

		$_POST['userid'] = $my->id;
		$_POST['videoid'] = $videoid;
		$_POST['ip'] = $ip;

		// bind it to the table
		if (!$row -> bind($_POST)) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row -> store()) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		//connecting to the database to get some information
		$numbers['total_votes'] = $rating_number_votes;
		$numbers['total_value'] = $rating_total_points;

		$count = $numbers['total_votes']; //how many votes total
		$current_rating = $numbers['total_value']; //total number of rating added together and stored
		$sum = $vote_sent+$current_rating; // add together the current vote value and the total vote value
		$tense = ($count==1) ? _HWDVIDS_INFO_M_VOTE : _HWDVIDS_INFO_M_VOTES; //plural form votes/vote

		// $new_back is what gets 'drawn' on your page after a successful 'AJAX/Javascript' vote

		$new_back = array();

		$new_back[] .= '<ul class="unit-rating" style="width:'.$units*$rating_unitwidth.'px;">';
		$new_back[] .= '<li class="current-rating" style="width:'.@number_format($new_rating,2)*$rating_unitwidth.'px;">'._HWDVIDS_INFO_CURRENTRATE.'</li>';
		$new_back[] .= '<li class="r1-unit">1</li>';
		$new_back[] .= '<li class="r2-unit">2</li>';
		$new_back[] .= '<li class="r3-unit">3</li>';
		$new_back[] .= '<li class="r4-unit">4</li>';
		$new_back[] .= '<li class="r5-unit">5</li>';
		$new_back[] .= '<li class="r6-unit">6</li>';
		$new_back[] .= '<li class="r7-unit">7</li>';
		$new_back[] .= '<li class="r8-unit">8</li>';
		$new_back[] .= '<li class="r9-unit">9</li>';
		$new_back[] .= '<li class="r10-unit">10</li>';
		$new_back[] .= '</ul>';
		$new_back[] .= '<p class="voted">'._HWDVIDS_INFO_RATED.'<strong>'.@number_format($new_rating,1).'</strong> ('.$count.' '.$tense.' '._HWDVIDS_INFO_M_CAST.') ';
		$new_back[] .= '<br /><span class="thanks">'._HWDVIDS_ALERT_THANKSVOTER.'</span></p>';

		$allnewback = join("\n", $new_back);

		// ========================

		//name of the div id to be updated | the html that needs to be changed
		$output = "unit_long$id_sent|$allnewback";
		echo $output;
		hwd_vs_tools::logRating( $videoid, $rating );

	exit;
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */

    function addToFavourites()
	{
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();

		if (!$my->id) {
			echo _HWDVIDS_AJAX_LOG2FAV1;
			exit;
		}

		$userid = $my->id;
		$videoid = JRequest::getInt( 'videoid', 0, 'request' );

		$where = ' WHERE a.userid = '.$userid;
		$where .= ' AND a.videoid = '.$videoid;

		$db->SetQuery( 'SELECT count(*)'
               		. ' FROM #__hwdvidsfavorites AS a'
               		. $where
               		);
  		$total = $db->loadResult();

		if ( $total>0 ) {
			echo _HWDVIDS_AJAX_ALREADYFAV;
			exit;
		}

		$row = new hwdvids_favs($db);

		$_POST['userid'] = $userid;
		$_POST['videoid'] = $videoid;

		// bind it to the table
		if (!$row -> bind($_POST)) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row -> store()) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		hwd_vs_tools::logFavour( $videoid, 1 );
		echo _HWDVIDS_AJAX_ADDEDFAV;
		exit;
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */

    function removeFromFavourites()
	{
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();

		if (!$my->id) {
			echo _HWDVIDS_AJAX_LOG2FAV2;
			exit;
		}

		$userid = $my->id;
		$videoid = JRequest::getInt( 'videoid', 0, 'request' );

		$where = ' WHERE userid = '.$userid;
		$where .= ' AND videoid = '.$videoid;

		$db->SetQuery( 'DELETE FROM #__hwdvidsfavorites'
               		. $where
               		);

		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}

		hwd_vs_tools::logFavour( $videoid, -1 );
		echo _HWDVIDS_AJAX_REMFAV;
		exit;
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */

    function reportVideo()
	{
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();

		if (!$my->id) {
			echo _HWDVIDS_AJAX_LOG2REPORT;
			exit;
		}

		$userid = $my->id;
		$videoid = JRequest::getInt( 'videoid', 0, 'request' );

		$where = ' WHERE a.videoid = '.$videoid;

		$db->SetQuery( 'SELECT count(*)'
               		. ' FROM #__hwdvidsflagged_videos AS a'
               		. $where
               		);
  		$total = $db->loadResult();

		if ( $total>0 ) {
			echo _HWDVIDS_AJAX_ALREADYREPORT;
			exit;
		}

		$row = new hwdvids_flagvid($db);

		$_POST['userid'] = $userid;
		$_POST['videoid'] = $videoid;
		$_POST['status'] = _HWDVIDS_UNREAD;
		$_POST['date'] = date('Y-m-d H:i:s');

		// bind it to the table
		if (!$row -> bind($_POST)) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row -> store()) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		echo _HWDVIDS_AJAX_VIDREPORT;
		exit;
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */

    function addVideoToGroup()
	{
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();

		if (!$my->id) {
			echo _HWDVIDS_AJAX_LOG2ADD2G;
			exit;
		}

		$user_id = $my->id;
		$videoid = JRequest::getInt( 'videoid', 0, 'request' );
		$groupid = JRequest::getInt( 'groupid', 0, 'request' );
		$date = date('Y-m-d H:i:s');
		$published = 1;

		if ($groupid == 0) {
			echo _HWDVIDS_ALERTSELGROUP;
			exit;
		}

		$where = ' WHERE a.videoid = '.$videoid;
		$where .= ' AND a.groupid = '.$groupid;

		$db->SetQuery( 'SELECT count(*)'
               		. ' FROM #__hwdvidsgroup_videos AS a'
               		. $where
               		);
  		$total = $db->loadResult();

		if ( $total>0 ) {
			echo _HWDVIDS_ALERT_ALREADYAV2G;
			exit;
		}

		$row = new hwdvids_groupvideo($db);

		$_POST['videoid'] = JRequest::getInt( 'videoid', 0, 'request' );
		$_POST['groupid'] = JRequest::getInt( 'groupid', 0, 'request' );
		$_POST['memberid'] = JRequest::getInt( 'userid', 0, 'request' );;
		$_POST['date'] = $date;

		// bind it to the table
		if (!$row -> bind($_POST)) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row -> store()) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// perform maintenance
		include(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/maintenance/recount.class.php');
		hwd_vs_recount::recountVideosInGroup($groupid);

		echo _HWDVIDS_ALERT_SUCAV2G;
		exit;
	}
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function grabJomSocialPlayer()
	{
		global $Itemid;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();

		$video_id = JRequest::getInt( 'video_id', 0 );

        // get video details
        $query = 'SELECT *'
                . ' FROM #__hwdvidsvideos'
                . ' WHERE id = '.$video_id
                ;

        $db->SetQuery( $query );
        $row = $db->loadObject();

		$videoplayer->title = stripslashes($row->title);
		$videoplayer->player = hwd_vs_tools::generateVideoPlayer($row);
		$videoplayer->videourl = hwd_vs_tools::generateVideoUrl($row);
		$videoplayer->embedcode = hwd_vs_tools::generateEmbedCode($row);
		$videoplayer->socialbmlinks = hwd_vs_tools::generateSocialBookmarks();
		$videoplayer->comments = hwd_vs_tools::generateVideoComments($row);
		if ($c->showrate == "1") {
			$videoplayer->ratingsystem = hwd_vs_tools::generateRatingSystem($row);
		}
		$videoplayer->comments = hwd_vs_tools::generateVideoComments($row);


		$code = null;
		$code.= '<div id="hwd_vs_joms">';
		$code.= '<div style="float:right;text-align:right;padding: 5px 0;"><a href="'.JURI::root( true ).'/index.php?option=com_hwdvideoshare&task=viewvideo&Itemid='.$Itemid.'&video_id='.$video_id.'" class="swap">'._HWDVIDS_DETAILS_GOTOVID.'</a> &raquo;</div>';
		$code.= '<h5 class="header">'.$videoplayer->title.'</h5>';
		$code.= '<div style="border:1px solid #ccc;margin-top:5px;padding:5px;"><center>'.$videoplayer->player.'<center></div>';
		$code.= '<div style="border:1px solid #ccc;margin-top:5px;">
		           <div style="float:left;text-align:left;padding: 5px;"><div id="hwdvids">'.$videoplayer->ratingsystem.'</div></div>
		           <div style="float:left;text-align:left;padding: 5px;">
                     <div>'._HWDVIDS_TITLE_PERMALINK.'<br /><input type="text" value="'.$videoplayer->videourl.'" width="90%" /></div>
                   </div>
		           <div style="float:left;text-align:left;padding: 5px;">
                     <div>'._HWDVIDS_INFO_VIDEMBEDCODE.'<br /><input type="text" value="'.$videoplayer->embedcode.'" width="90%" /></div>
                   </div>
		           <div style="clear:both;"></div>
                 </div>';
		$code.= '<div style="border:1px solid #ccc;padding:5px;margin-top:5px;text-align:center;">'.$videoplayer->socialbmlinks.'</div>';
		$code.= '<div style="border:1px solid #ccc;padding:5px;margin-top:5px;text-align:left;">'.$videoplayer->comments.'</div>';
		$code.= '</div>';




		print $code;
		exit;
	}
}
?>