<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
 * This class is the HTML generator for hwdVideoShare frontend
 *
 * @package    hwdVideoShare
 * @author     Dave Horsfall <info@highwooddesign.co.uk>
 * @copyright  2008 Highwood Design
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version    1.1.4 Alpha RC2.13
 */
class HWDVS_xmlOutput
{
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function checkCacheThenWrite()
    {
    	// get general configuration data
		$c = hwd_vs_Config::get_instance();
  		$db =& JFactory::getDBO();
		$my = & JFactory::getUser();

		// set cache variables
		$cachedir = HWDVIDSPATH.'/xml/cache/'; // Directory to cache files in (keep outside web root)
		$cacheext = 'cache'; // Extension to give cached files (usually cache, htm, txt)

		/**
		 * Generate Today's Playlists
		 */
		$cachetime = $c->xmlcache_today; // Seconds to cache files for
		$page = 'http://xmlplaylists_today'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$cachefile_created = (@file_exists($cachefile)) ? @filemtime($cachefile) : 0;
		@clearstatcache();

		// Show file from cache if still valid
		if (time() - $cachetime < $cachefile_created) {
			//echo "ALREADY CACHED";
		} else {
			 // Now the script has run, generate a new cache file
			$fp = @fopen($cachefile, 'w');

			// save the contents of output buffer to the file
			@fwrite($fp, ob_get_contents());
			@fclose($fp);

			// sql search filters
			$where = ' WHERE published = 1';
			$where .= ' AND approved = "yes"';
			if (!$my->id) {
			$where .= ' AND public_private = "public"';
			}

			$join = ' LEFT JOIN #__users ON #__users.id = #__hwdvidsvideos.user_id';
			$select = '#__users.username,';
			if ($c->cbint == "2") {
				$join.= ' LEFT JOIN #__community_users ON #__community_users.userid = #__hwdvidsvideos.user_id';
				$select.= ' #__community_users.*,';
			} else if ($c->cbint == "1") {
				$join.= ' LEFT JOIN #__comprofiler ON #__comprofiler.id = #__hwdvidsvideos.user_id';
				$select.= ' #__comprofiler.*,';
			}

			// query SQL for today's data
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' COUNT(#__hwdvidslogs_views.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_views ON #__hwdvidsvideos.id = #__hwdvidslogs_views.videoid '.$join.' WHERE #__hwdvidslogs_views.date >= DATE_SUB(NOW(),INTERVAL 1 DAY) GROUP BY #__hwdvidsvideos.id ORDER BY counts DESC LIMIT 0, 10');
			$rowsmostviewed_today = $db->loadObjectList();
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' COUNT(#__hwdvidslogs_favours.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_favours ON #__hwdvidsvideos.id = #__hwdvidslogs_favours.videoid '.$join.' WHERE #__hwdvidslogs_favours.date >= DATE_SUB(NOW(),INTERVAL 1 DAY) AND favour = 1 GROUP BY #__hwdvidsvideos.id ORDER BY counts DESC LIMIT 0, 10');
			$rowsmostfavoured_today = $db->loadObjectList();
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' SUM(#__hwdvidslogs_votes.vote)/COUNT(#__hwdvidslogs_votes.videoid) AS sums, COUNT(#__hwdvidslogs_votes.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_votes ON #__hwdvidsvideos.id = #__hwdvidslogs_votes.videoid '.$join.' WHERE #__hwdvidslogs_votes.date >= DATE_SUB(NOW(),INTERVAL 1 DAY) GROUP BY #__hwdvidsvideos.id ORDER BY sums DESC LIMIT 0, 10');
			$rowsmostpopular_today = $db->loadObjectList();
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostviewed_today, 'mostviewed_today');
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostfavoured_today, 'mostfavoured_today');
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostpopular_today, 'mostpopular_today');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostviewed_today, 'mostviewed_today');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostfavoured_today, 'mostfavoured_today');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostpopular_today, 'mostpopular_today');
		}

		/**
		 * Generate This Weeks's Playlists
		 */
		$cachetime = $c->xmlcache_thisweek; // Seconds to cache files for
		$page = 'http://xmlplaylists_thisweek'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$cachefile_created = (@file_exists($cachefile)) ? @filemtime($cachefile) : 0;
		@clearstatcache();

		// Show file from cache if still valid
		if (time() - $cachetime < $cachefile_created) {
			//echo "ALREADY CACHED";
		} else {
			 // Now the script has run, generate a new cache file
			$fp = @fopen($cachefile, 'w');

			// save the contents of output buffer to the file
			@fwrite($fp, ob_get_contents());
			@fclose($fp);

			// sql search filters
			$where = ' WHERE published = 1';
			$where .= ' AND approved = "yes"';
			if (!$my->id) {
			$where .= ' AND public_private = "public"';
			}

			$join = ' LEFT JOIN #__users ON #__users.id = #__hwdvidsvideos.user_id';
			$select = '#__users.username,';
			if ($c->cbint == "2") {
				$join.= ' LEFT JOIN #__community_users ON #__community_users.userid = #__hwdvidsvideos.user_id';
				$select.= ' #__community_users.*,';
			} else if ($c->cbint == "1") {
				$join.= ' LEFT JOIN #__comprofiler ON #__comprofiler.id = #__hwdvidsvideos.user_id';
				$select.= ' #__comprofiler.*,';
			}

			// query SQL for this week's data
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' COUNT(#__hwdvidslogs_views.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_views ON #__hwdvidsvideos.id = #__hwdvidslogs_views.videoid '.$join.' WHERE #__hwdvidslogs_views.date >= DATE_SUB(NOW(),INTERVAL 7 DAY) GROUP BY #__hwdvidsvideos.id ORDER BY counts DESC LIMIT 0, 10');
			$rowsmostviewed_thisweek = $db->loadObjectList();
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' COUNT(#__hwdvidslogs_favours.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_favours ON #__hwdvidsvideos.id = #__hwdvidslogs_favours.videoid '.$join.' WHERE #__hwdvidslogs_favours.date >= DATE_SUB(NOW(),INTERVAL 7 DAY) GROUP BY #__hwdvidsvideos.id ORDER BY counts DESC LIMIT 0, 10');
			$rowsmostfavoured_thisweek = $db->loadObjectList();
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' SUM(#__hwdvidslogs_votes.vote)/COUNT(#__hwdvidslogs_votes.videoid) AS sums, COUNT(#__hwdvidslogs_votes.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_votes ON #__hwdvidsvideos.id = #__hwdvidslogs_votes.videoid '.$join.' WHERE #__hwdvidslogs_votes.date >= DATE_SUB(NOW(),INTERVAL 7 DAY) GROUP BY #__hwdvidsvideos.id ORDER BY sums DESC LIMIT 0, 10');
			$rowsmostpopular_thisweek = $db->loadObjectList();
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostviewed_thisweek, 'mostviewed_thisweek');
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostfavoured_thisweek, 'mostfavoured_thisweek');
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostpopular_thisweek, 'mostpopular_thisweek');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostviewed_thisweek, 'mostviewed_thisweek');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostfavoured_thisweek, 'mostfavoured_thisweek');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostpopular_thisweek, 'mostpopular_thisweek');

			if (!empty($c->xmlcustom01)) {
				$playlist = explode(",", $c->xmlcustom01);
				$playlist = preg_replace("/[^0-9]/", "", $playlist);
				$playlist = implode(",", $playlist);
				$db->SetQuery('SELECT * FROM #__hwdvidsvideos WHERE id IN ('.$playlist.')');
				$rows_custom01 = $db->loadObjectList();
				HWDVS_xmlOutput::writeXMLDataFile($rows_custom01, 'custom01');
				HWDVS_xmlOutput::writeXMLPlaylistFile($rows_custom01, 'custom01');
			}
			if (!empty($c->xmlcustom02)) {
				$playlist = explode(",", $c->xmlcustom02);
				$playlist = preg_replace("/[^0-9]/", "", $playlist);
				$playlist = implode(",", $playlist);
				$db->SetQuery('SELECT * FROM #__hwdvidsvideos WHERE id IN ('.$playlist.')');
				$rows_custom02 = $db->loadObjectList();
				HWDVS_xmlOutput::writeXMLDataFile($rows_custom02, 'custom02');
				HWDVS_xmlOutput::writeXMLPlaylistFile($rows_custom02, 'custom02');
			}
			if (!empty($c->xmlcustom03)) {
				$playlist = explode(",", $c->xmlcustom03);
				$playlist = preg_replace("/[^0-9]/", "", $playlist);
				$playlist = implode(",", $playlist);
				$db->SetQuery('SELECT * FROM #__hwdvidsvideos WHERE id IN ('.$playlist.')');
				$rows_custom03 = $db->loadObjectList();
				HWDVS_xmlOutput::writeXMLDataFile($rows_custom03, 'custom03');
				HWDVS_xmlOutput::writeXMLPlaylistFile($rows_custom03, 'custom03');
			}
			if (!empty($c->xmlcustom04)) {
				$playlist = explode(",", $c->xmlcustom04);
				$playlist = preg_replace("/[^0-9]/", "", $playlist);
				$playlist = implode(",", $playlist);
				$db->SetQuery('SELECT * FROM #__hwdvidsvideos WHERE id IN ('.$playlist.')');
				$rows_custom04 = $db->loadObjectList();
				HWDVS_xmlOutput::writeXMLDataFile($rows_custom04, 'custom04');
				HWDVS_xmlOutput::writeXMLPlaylistFile($rows_custom04, 'custom04');

			}
			if (!empty($c->xmlcustom05)) {
				$playlist = explode(",", $c->xmlcustom05);
				$playlist = preg_replace("/[^0-9]/", "", $playlist);
				$playlist = implode(",", $playlist);
				$db->SetQuery('SELECT * FROM #__hwdvidsvideos WHERE id IN ('.$playlist.')');
				$rows_custom05 = $db->loadObjectList();
				HWDVS_xmlOutput::writeXMLDataFile($rows_custom05, 'custom05');
				HWDVS_xmlOutput::writeXMLPlaylistFile($rows_custom05, 'custom05');
			}
		}

		/**
		 * Generate This Month's Playlists
		 */
		$cachetime = $c->xmlcache_thismonth; // Seconds to cache files for
		$page = 'http://xmlplaylists_thismonth'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$cachefile_created = (@file_exists($cachefile)) ? @filemtime($cachefile) : 0;
		@clearstatcache();

		// Show file from cache if still valid
		if (time() - $cachetime < $cachefile_created) {
			//echo "ALREADY CACHED";
		} else {
			 // Now the script has run, generate a new cache file
			$fp = @fopen($cachefile, 'w');

			// save the contents of output buffer to the file
			@fwrite($fp, ob_get_contents());
			@fclose($fp);

			$join = ' LEFT JOIN #__users ON #__users.id = #__hwdvidsvideos.user_id';
			$select = '#__users.username,';
			if ($c->cbint == "2") {
				$join.= ' LEFT JOIN #__community_users ON #__community_users.userid = #__hwdvidsvideos.user_id';
				$select.= ' #__community_users.*,';
			} else if ($c->cbint == "1") {
				$join.= ' LEFT JOIN #__comprofiler ON #__comprofiler.id = #__hwdvidsvideos.user_id';
				$select.= ' #__comprofiler.*,';
			}

			// sql search filters
			$where = ' WHERE published = 1';
			$where .= ' AND approved = "yes"';
			if (!$my->id) {
			$where .= ' AND public_private = "public"';
			}

			// query SQL for this month's data
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' COUNT(#__hwdvidslogs_views.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_views ON #__hwdvidsvideos.id = #__hwdvidslogs_views.videoid '.$join.' WHERE #__hwdvidslogs_views.date >= DATE_SUB(NOW(),INTERVAL 30 DAY) GROUP BY #__hwdvidsvideos.id ORDER BY counts DESC LIMIT 0, 10');
			$rowsmostviewed_thismonth = $db->loadObjectList();
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' COUNT(#__hwdvidslogs_favours.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_favours ON #__hwdvidsvideos.id = #__hwdvidslogs_favours.videoid '.$join.' WHERE #__hwdvidslogs_favours.date >= DATE_SUB(NOW(),INTERVAL 30 DAY) GROUP BY #__hwdvidsvideos.id ORDER BY counts DESC LIMIT 0, 10');
			$rowsmostfavoured_thismonth = $db->loadObjectList();
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' SUM(#__hwdvidslogs_votes.vote)/COUNT(#__hwdvidslogs_votes.videoid) AS sums, COUNT(#__hwdvidslogs_votes.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_votes ON #__hwdvidsvideos.id = #__hwdvidslogs_votes.videoid '.$join.' WHERE #__hwdvidslogs_votes.date >= DATE_SUB(NOW(),INTERVAL 30 DAY) GROUP BY #__hwdvidsvideos.id ORDER BY sums DESC LIMIT 0, 10');
			$rowsmostpopular_thismonth = $db->loadObjectList();
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostviewed_thismonth, 'mostviewed_thismonth');
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostfavoured_thismonth, 'mostfavoured_thismonth');
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostpopular_thismonth, 'mostpopular_thismonth');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostviewed_thismonth, 'mostviewed_thismonth');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostfavoured_thismonth, 'mostfavoured_thismonth');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostpopular_thismonth, 'mostpopular_thismonth');
		}

		/**
		 * Generate All Time Playlists
		 */
		$cachetime = $c->xmlcache_thismonth; // Seconds to cache files for
		$page = 'http://xmlplaylists_alltime'; // Requested page
		$cachefile = $cachedir . md5($page) . '.' . $cacheext; // Cache file to either load or create
		$cachefile_created = (@file_exists($cachefile)) ? @filemtime($cachefile) : 0;
		@clearstatcache();

		// Show file from cache if still valid
		if (time() - $cachetime < $cachefile_created) {
			//echo "ALREADY CACHED";
		} else {
			 // Now the script has run, generate a new cache file
			$fp = @fopen($cachefile, 'w');

			// save the contents of output buffer to the file
			@fwrite($fp, ob_get_contents());
			@fclose($fp);

			// sql search filters
			$where = ' WHERE published = 1';
			$where .= ' AND approved = "yes"';
			if (!$my->id) {
			$where .= ' AND public_private = "public"';
			}

			$join = ' LEFT JOIN #__users ON #__users.id = #__hwdvidsvideos.user_id';
			$select = '#__users.username,';
			if ($c->cbint == "2") {
				$join.= ' LEFT JOIN #__community_users ON #__community_users.userid = #__hwdvidsvideos.user_id';
				$select.= ' #__community_users.*,';
			} else if ($c->cbint == "1") {
				$join.= ' LEFT JOIN #__comprofiler ON #__comprofiler.id = #__hwdvidsvideos.user_id';
				$select.= ' #__comprofiler.*,';
			}

			// query SQL for all data
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' COUNT(#__hwdvidslogs_views.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_views ON #__hwdvidsvideos.id = #__hwdvidslogs_views.videoid '.$join.' GROUP BY #__hwdvidsvideos.id ORDER BY counts DESC LIMIT 0, 10');
			$rowsmostviewed_alltime = $db->loadObjectList();
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' COUNT(#__hwdvidslogs_favours.videoid) AS counts FROM #__hwdvidsvideos LEFT JOIN #__hwdvidslogs_favours ON #__hwdvidsvideos.id = #__hwdvidslogs_favours.videoid '.$join.' GROUP BY #__hwdvidsvideos.id ORDER BY counts DESC LIMIT 0, 10');
			$rowsmostfavoured_alltime = $db->loadObjectList();
			$db->SetQuery('SELECT #__hwdvidsvideos.*, '.$select.' FROM #__hwdvidsvideos '.$join.' ORDER BY #__hwdvidsvideos.updated_rating DESC, rating_number_votes DESC LIMIT 0, 10');
			$rowsmostpopular_alltime = $db->loadObjectList();
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostviewed_alltime, 'mostviewed_alltime');
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostfavoured_alltime, 'mostfavoured_alltime');
			HWDVS_xmlOutput::writeXMLDataFile($rowsmostpopular_alltime, 'mostpopular_alltime');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostviewed_alltime, 'mostviewed_alltime');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostfavoured_alltime, 'mostfavoured_alltime');
			HWDVS_xmlOutput::writeXMLPlaylistFile($rowsmostpopular_alltime, 'mostpopular_alltime');
		}
		return;
	}

    /**
     * Make xml playlist for mostviewed (today) which will
     * be used by the hwdVideoShare modules.
     *
     * @return       True
     */
    function writeXMLDataFile($rows, $filename)
    {
		global $limitstart, $mainframe, $Itemid;
    	// get general configuration data
		$c = hwd_vs_Config::get_instance();

		$configfile = HWDVIDSPATH.'/xml/'.$filename.'.xml';
		if (!file_exists($configfile)) {
			$fo = @fopen($configfile, 'w');
			@fclose($fo);
		}

		@chmod ($configfile, 0777);
		$permission = is_writable($configfile);
		if (!$permission) {
			// maybe send email?
			return;
		}
		$config = null;
		$config .= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		$config .= "<playlist version=\"1\">\n";
		$config .= "<title>hwdVideoShare ".$filename." Playlist</title>\n";
		$config .= "<info>http:/xspf.org/xspf-v1.html</info>\n";
		$config .= "<trackList>\n";
		$config .= "\n";
		// print out playlist
		for ($i=0, $n=count($rows); $i < $n; $i++) {
			$row = $rows[$i];

			// $row->title = utf8_encode(HWDVS_xmlOutput::XMLEntities($row->title));
			// $row->description = utf8_encode(HWDVS_xmlOutput::XMLEntities($row->description));
			// $row->title = htmlspecialchars(HWDVS_xmlOutput::XMLEntities($row->title));
			// $row->description = htmlspecialchars(HWDVS_xmlOutput::XMLEntities($row->description));
			// echo $row->title."<br />";

			$row->title = HWDVS_xmlOutput::XMLEntities($row->title);
			$row->title = HWDVS_xmlOutput::charset_decode_utf_8($row->title);

			$row->description = HWDVS_xmlOutput::XMLEntities($row->description);
			$row->description = HWDVS_xmlOutput::charset_decode_utf_8($row->description);

			// echo $row->title."<br />";

			$video_code = explode(",", $row->video_id);
			if (empty($video_code[1])) {
				$row->video_id = HWDVS_xmlOutput::XMLEntities($row->video_id);
			} else {
				$video_code[0] = HWDVS_xmlOutput::XMLEntities($video_code[0]);
				$video_code[1] = urlencode($video_code[1]);
				$row->video_id = implode(",", $video_code);
			}

			if (empty($row->video_length)) {
				$row->video_length = "0:00:00";
			}

			$config .= "  <track>\n";
			$config .= "    <id><![CDATA[".$row->id."]]></id>\n";
			$config .= "    <videotitle><![CDATA[".$row->title."]]></videotitle>\n";
			$config .= "    <videocode><![CDATA[".$row->video_id."]]></videocode>\n";
			$config .= "    <videotype><![CDATA[".$row->video_type."]]></videotype>\n";
			$config .= "    <category><![CDATA[]]></category>\n";
			$config .= "    <category_id><![CDATA[".$row->category_id."]]></category_id>\n";
			$config .= "    <description><![CDATA[".$row->description."]]></description>\n";
			$config .= "    <views><![CDATA[".$row->number_of_views."]]></views>\n";
			$config .= "    <duration><![CDATA[".$row->video_length."]]></duration>\n";
			$config .= "    <rating><![CDATA[".$row->updated_rating."]]></rating>\n";
			$config .= "    <uploader><![CDATA[".$row->username."]]></uploader>\n";
			$config .= "    <uploader_id><![CDATA[".$row->user_id."]]></uploader_id>\n";
			if ($c->cbint !== "0" && !empty($row->avatar)) {
				$avatar = $row->avatar;
			} else {
				$avatar = "";
			}
			$config .= "    <avatar><![CDATA[".$avatar."]]></avatar>\n";
			$config .= "  </track>\n";
			$config .= "\n";
		}
		$config .= "</trackList>\n";
		$config .= "</playlist>\n";

		if ($fp = @fopen("$configfile", "w")) {
			fputs($fp, $config, strlen($config));
			fclose ($fp);
		}

		return true;
    }

    /**
     * Make xml playlist for mostviewed (today) which will
     * be used by the hwdVideoShare modules.
     *
     * @return       True
     */
    function writeXMLPlaylistFile($rows, $filename)
    {
		global $limitstart, $database, $mainframe, $Itemid;

		$configfile = HWDVIDSPATH.'/xml/xspf/'.$filename.'.xml';
		if (!file_exists($configfile)) {
			$fo = @fopen($configfile, 'w');
			@fclose($fo);
		}

		@chmod ($configfile, 0777);
		$permission = is_writable($configfile);
		if (!$permission) {
			// maybe send email?
			return;
		}
		$config = null;

		$config = null;
		$config .= "<playlist version=\"1\" xmlns=\"http://xspf.org/ns/0/\">\n";
		$config .= "<title>hwdVideoShare Playlist</title>\n";
		$config .= "<info>http:/xspf.org/xspf-v1.html</info>\n";
		$config .= "<trackList>\n";
		$config .= "\n";

		// print out playlist
		for ($i=0, $n=count($rows); $i < $n; $i++) {
			$row = $rows[$i];

			if ($row->video_type == "local") {
				$location = JURI::base( true )."/hwdvideos/uploads/".$row->video_id.".flv";
				$image = JURI::base( true )."/hwdvideos/thumbs/".$row->video_id.".jpg";
			} else if ($row->video_type == "remote") {
				if (@explode(",", $row->video_id)) {
					$data = explode(",", $row->video_id);
					$location = $data[0];
					$image = $data[1];
				}
			} else if ($row->video_type == "swf") {
				$location = JURI::base( true )."/hwdvideos/uploads/".$row->video_id.".swf";
				$image = JURI::base( true )."/hwdvideos/thumbs/".$row->video_id.".jpg";
			} else {

				$plugin = hwd_vs_tools::getPluginDetails($row->video_type);
				if (!$plugin) {
					continue;
				} else {
					$prepareflvurl = preg_replace("/[^a-zA-Z0-9s_-]/", "", $row->video_type)."prepareflvurl";
					$flvurl = $prepareflvurl($row->video_id, $row->id, $Itemid);
					if (!empty($flvurl)) {
						$location = $flvurl;
					} else {
						continue;
					}

					if (@explode(",", $row->video_id)) {
						$data = explode(",", $row->video_id);
						$image = urldecode($data[1]);
					}
				}
			}

		    $config .= "  <track>\n";
		    $config .= "    <location><![CDATA[".trim($location)."]]></location>\n";
		    $config .= "    <image><![CDATA[".trim($image)."]]></image>\n";
			$config .= "	<meta rel='type'>flv</meta>\n";
		    $config .= "  </track>\n";
		    $config .= "\n";
		}

		$config .= "</trackList>\n";
		$config .= "</playlist>\n";

		if ($fp = @fopen("$configfile", "w")) {
			fputs($fp, $config, strlen($config));
			fclose ($fp);
		}

		return true;
    }

    function XMLEntities($string)
    {
		$string = str_replace("&", "&#38;", $string);
		$string = str_replace("<", "&#60;", $string);
		$string = str_replace(">", "&#62;", $string);
		$string = str_replace("\"", "&#39;", $string);
		$string = str_replace("'", "&#39;", $string);
		$string = str_replace("", "&#169;", $string);
		$string = str_replace("", "&#174;", $string);
		$string = str_replace("", "&#201;", $string);
		$string = str_replace("", "&#250;", $string);
		$string = str_replace("", "&#233;", $string);
		$string = str_replace("", "&#225;", $string);
		return $string;
    }

	function charset_decode_utf_8 ($string) {
		/* Only do the slow convert if there are 8-bit characters */
		/* avoid using 0xA0 (\240) in ereg ranges. RH73 does not like that */
		if (! ereg("[\200-\237]", $string) and ! ereg("[\241-\377]", $string))
			return $string;

		// decode three byte unicode characters
		$string = preg_replace("/([\340-\357])([\200-\277])([\200-\277])/e",
		"'&#'.((ord('\\1')-224)*4096 + (ord('\\2')-128)*64 + (ord('\\3')-128)).';'",
		$string);

		// decode two byte unicode characters
		$string = preg_replace("/([\300-\337])([\200-\277])/e",
		"'&#'.((ord('\\1')-192)*64+(ord('\\2')-128)).';'",
		$string);

		return $string;
	}

}
?>